/*------------------------------------------------------------------------
   (C) Copyright Marxmeier Software AG 2002,2003
   
   Project:  ELOQUENCE
   Module:   dllif
   File:     dllif.h
   Function: DLL interface header file

   Note: This file should NOT be included when processing
   a source with dllcc
   
   Edit history:
   22.11.1990 - creation
   20.12.1992 - K&R compliance
   20.01.1995 - MAX_ARGUMENT 20 -> 50
   21.02.2003 - LP64 clean

------------------------------------------------------------------------*/

/* @(#)$Revision: 27.2 $ */

#ifndef _DLLIF_INCLUDED
#define _DLLIF_INCLUDED

/*------------------------------------------------------------------------
      DLL interface limits
------------------------------------------------------------------------*/

#define MAX_ARGUMENT 50


/*------------------------------------------------------------------------
      external variables
------------------------------------------------------------------------*/

extern int dll_debug;


/*------------------------------------------------------------------------
      DLL interface types
------------------------------------------------------------------------*/

typedef int EqDLL;

typedef void EqVoid;
typedef int EqInt;
typedef double EqReal;
typedef char EqChar;

struct EqString {
   int maxl;         /* maximum string length */
   int l;            /* current string length */
   char *p;          /* string value */
};

typedef struct EqString EqString;

/*------------------------------------------------------------------------
      DLL interface utility types
------------------------------------------------------------------------*/

enum EqArgType {
   EqArg_VarArg,
   EqArg_IntByValue,
   EqArg_IntByReference,
   EqArg_IntArray,
   EqArg_RealByValue,
   EqArg_RealByReference,
   EqArg_RealArray,
   EqArg_zString,
   EqArg_String,
   EqArg_StringArray
};

struct EqFuncInfo {
   char *name;
   int arg_cnt;
};

struct EqArgInfo {
   enum EqArgType type;
   char *name;
   int elcnt;
};

struct EqFuncList {
   char *name;
   int arg_idx;
   int arg_cnt;
   int call_arg_cnt;
};

struct EqArgList {
   char *name;
   enum EqArgType type;
   int size;
};

/*------------------------------------------------------------------------
      DLL interface utility function prototypes
------------------------------------------------------------------------*/

#ifdef __STDC__
# define _p1(a)     a
# define _p2(a,b)   a,b
# define _p3(a,b,c) a,b,c
#else
# define _p1(a)
# define _p2(a,b)
# define _p3(a,b,c)
#endif

struct EqFuncInfo *EqFuncInfo( _p1(void) );
struct EqArgInfo *EqArgInfo( _p1(void *arg) );
int EqStrlen( _p1(EqString *s) );
int EqMaxStrlen( _p1(EqString *s) );
int EqStrcat( _p2(EqString *s1, EqString *s2) );
int EqStrcpy( _p2(EqString *s1, EqString *s2) );
int EqStrcmp( _p2(EqString *s1, EqString *s2) );
EqString *EqSubstr( _p3(EqString *s, int start, int len) );
int EqStr2str( _p2(EqString *eq, void *s) );
int str2EqStr( _p2(void *s, EqString *eq) );
EqString *EqMkstr( _p1(int maxl) );

#undef _p1
#undef _p2
#undef _p3

#endif /* _DLLIF_INCLUDED */
